#!/usr/bin/env perl

# this code is distributed under the terms of the GNU Public License (GPL), see the file "LICENSE" for more information.
# Copyright 2004 Thomas Langewouters.


use strict;
my $parameter = shift;
my $version = "1.1.6";
# zet $debug = 1 bij het debuggen....
my $debug = 0;
my $login;
my $password;
my $keep_cookiefile;
my $cookiefile;

sub curl_get_url
{
	my $url = shift; 
	my $command = "curl -k -s -L -b $cookiefile -c $cookiefile $url";
	return `$command`;
}

sub curl_post_url
{
	my $url = shift; my $postdata = shift;
	my $command ="curl -k -s -L -c $cookiefile -b $cookiefile -d \"$postdata\" $url";
	return `$command`;
}

if( $parameter and $parameter eq "--help" )
{
	print "Skymeter $version\n";
	print "Geschreven door Thomas Langewouters\n";
	print "Deze software valt onder de GNU Public License.\n";
	print "Usage: skymeter.pl [switches]\n";
	print "  --help\tDisplay this message\n";
	print "  -u/--update\tCheck the internet for an update\n\t\t(doesn't download or install new version)\n";
	print "\n";
	exit 0;
}

sub check_for_update
{
	print "Controleren op update...\n";
	my $webpage = curl_get_url("http://users.skynet.be/langewouters/skymeter_version.xml");
	if ($debug)
	{
		print $webpage;
	}

	if ($webpage =~ /<xml>/) 
	{
		$webpage =~ /<currentversion>(.*)<\/currentversion>/;
	    	my $newest = $1;
	
		print "Huidige versie: $version, recentste: $newest\n";
		$webpage =~ /<comment>(.*)<\/comment>/;
		my $comment = $1;
		print "Opmerking bij nieuwste versie: $comment\n";

	} else {
		print "skymeter: FOUT: pagina niet gevonden\n";
	}
}

if( $parameter and ($parameter eq "-u" or $parameter eq "--update"))
{
	check_for_update;
	exit 0;
}

# Preform Skymeter magic....... ---------------------

# skymeter.secrets bevat:
#	user uw_gebruikersnaam
#	pass uw_paswoord
#	cookiefile keep
# de kymeter.secrets file zou omwille van veiligheidsredenen
# alleen leesbaar mogen zijn door de gebruiker die skymeter gebruikt.

# haal user, passwoord, en instellingen uit de configfile

$cookiefile = "/tmp/skymeter.cookie";

open(INFILE,  "/etc/skymeter.secrets") or die "Can't open secrets file: $!";
while (<INFILE>) {     # assigns each line in turn to $_ 
	if ($_ =~ /user (.*)/) { $login = $1; }
	if ($_ =~ /pass (.*)/) { $password = $1}
	if ($_ =~ /cookiefile keep/) { $keep_cookiefile = 1}
}
close (INFILE);

if ($debug)
{
	print "login: -$login-, password -$password-\n";
}

if (! $login || ! $password)
{
	die "skymeter: FOUT: Geen username of paswoord opgegeven\n";
}


print "Volumemeter opvragen... ";
my $webpage;
$webpage =  curl_get_url("https://e-care.skynet.be/App/ConTime/index.cfm?fuseaction=VolumeMeter");

if ($debug) {
	open(OUTFILE, ">webpage1.html") or die "Can't open webpage1.html: $!";
	print OUTFILE $webpage;
}

if ($webpage =~ /Ziehier/)
{
	print "Authenticatie geslaagd!\n";
}
else
{
	# anders moeten we nog inloggen
	print "Inloggen... ";
	my $postdata="form_login=$login&form_password=$password&Langue_Id=2&fuseaction=CheckLoginConnection";
	$webpage = curl_post_url("https://e-care.skynet.be/Login/index.cfm", $postdata);
 
	if ($webpage =~ /Ziehier/)
	{
			print "Authenticatie geslaagd!\n";
	}
	else
	{
			die "skymeter: FOUT: authenticatie MISLUKT!!!\n Controleer uw username/paswoord.  Als dit niet helpt, controleer op een nieuwe versie van skymeter met \"skymeter.pl --update\"\n";	
				
	}

	print "Volumemeter opvragen... \n";
	$webpage = curl_get_url("https://e-care.skynet.be/App/ConTime/index.cfm?fuseaction=VolumeMeter");
}

if (! $keep_cookiefile) {
	print `rm $cookiefile`;
}

if ($debug) {
	open(OUTFILE, ">webpage.txt") or die "Can't open webpage.txt: $!";
	print OUTFILE $webpage;
}

$webpage =~ /Gebruikt volume voor deze maand <font class="thirdlevel">\s*(\d*\.*\d*) GB<\/font> van de beschikbare (\d+) GB/;
    
my $basis_used = $1;
my $basis_total = $2;

$webpage =~ /Gebruikt Extra Volume <font class="thirdlevel">\s*(\d*\.*\d*) GB<\/font> van de beschikbare (\d+) GB/;
my $volumepack_used = $1;
my $volumepack_total = $2;

if ($basis_total == "")
{
	print "\nskymeter: FOUT: Pagina veranderd.\n\n";
	check_for_update();
	exit 1;
}

if ($basis_used / $basis_total == 1) 
{
	print "Volledig basisvollume gebruikt \n";
	if ($webpage =~ /Huidig Volume Pack :/) 
	{
		print "Lopende volumepack: [$volumepack_used / $volumepack_total]\n";
	}
} 
else
{
	print "Basisvolume [$basis_used / $basis_total] \n";
}

